<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <title>Serviceblick Easy2Track Besucher</title>
    <link href="./pbcdn/css/spinner.css?v=[cs_version]" rel="stylesheet">
    <link rel="stylesheet" href="./pbcdn/css/bootstrap.min.css">
    <link rel="stylesheet" href="./pbcdn/css/font-awesome.min.css">

    <link href="./global/vendor/semanticui/semantic.min.css?v=[cs_version]" rel="stylesheet">
    <link rel="stylesheet" media="all" href="./pbcdn/css/jquery.dynatable.css"/>
    <link href="./css/base.css?v=[cs_version]" rel="stylesheet">
    <link href="./css/app.css?v=[cs_version]" rel="stylesheet">

</head>
<body>
<div id="spinner">
    <div class="loader">
        <div class="face">
            <div class="circle"></div>
        </div>
        <div class="face">
            <div class="circle"></div>
        </div>
        <div id="spinner_message">
            System wird geladen...
        </div>
    </div>
</div>
<div id="foobar" class="ui sidebar inverted vertical menu">

</div>
<div class="pusher">
    <!-- Site content !-->
    <nav class="navbar navbar-expand-md navbar-dark bg-dark mb-3">
        <div class="container-fluid">
            <a href="#" class="navbar-brand mr-3">Serviceblick</a>
            <button type="button" class="navbar-toggler" data-toggle="collapse" data-target="#navbarCollapse">
                <span class="navbar-toggler-icon"></span>
            </button>
            <div class="collapse navbar-collapse" id="navbarCollapse">
                <div class="navbar-nav">
                    <a href="../dashboard/" class="nav-item nav-link">Dashboard</a>
                    <a href="https://impressum.planblick.com/" class="nav-item nav-link">Impressum</a>
                    <a href="https://datenschutz.planblick.com/" class="nav-item nav-link">Datenschutz</a>
                    <a href="https://www.crowdsoft.net/support/" target="_blank" class="nav-item nav-link">Support</a>
                </div>
                <div class="navbar-nav ml-auto">
                    <a href="#" onclick="logout();return false;" class="nav-item nav-link">Abmelden</a>
                </div>
            </div>
        </div>
    </nav>
    <div class="">
        <div class="row">
            <button id="menu_wrapper_button" onclick=" $('.ui.sidebar').sidebar('toggle');" type="button" class="btn btn-primary btn-lg btn-block" data-toggle="collapse">
                <span class="navbar-toggler-icon" style="color:#000000;">Menü</span>
            </button>
            <div id="menu_wrapper" class="col-md-3 col-lg-2 col-xl-2 ui vertical menu menu_wrapper">
                <!--div id="subnavbarCollapse">
                    <div class="item">
                        <div class="header">Filter</div>
                        <div class="menu">
                            <a class="user outline icon teal item" onclick="pb_events.content_switched(this);return false;" data-content="content_1">
                                <i class="user outline icon left"></i>
                                Datum
                            </a>
                        </div>
                    </div>
                </div-->
            </div>



            <div class="col-md-9 col-lg-10 col-xl-10 active" data-content="content_1">
                <div class="row sub">
                    <div class="col-md-2 col-lg-2 col-xl-2">
                        <h2 style="text-align:center; width:100%;">Besucher-Anzahl</h2>
                        <p class="current_visitors">
                            <div class="current_visitors">aktuell</div><div class="current_visitors" id="current_visitors">0</div>
                        </p>
                        <p class="todays_visitors">
                            <div class="todays_visitors">heute:</div><div class="todays_visitors" id="sum_visitors">0</div>
                        </p>
                        <p class="average_duration">
                            <div class="average_duration">Ø Aufenthalt (min):</div><div class="average_duration" id="average_duration">0</div>
                        </p>
                    </div>
                    <div class="col-md-9 col-lg-9 col-xl-9">
                        <h2>Besucher-Liste</h2>
                        <p><span class="setting_name">Auto-Checkout nach: </span><input id="auto_logout_minutes" onchange="fetchData();" value="180"/><span>min</span></p>
                        <p>
                            <div class="container">
                                <table id="example" class="table table-striped table-bordered" cellspacing="0" width="100%">
                                    <thead>
                                    <th data-dynatable-column="id">Besucher ID</th>
                                    <th data-dynatable-column="checkedin_formatted">Check IN</th>
                                    <th data-dynatable-column="checkedout_formatted">Check OUT</th>
                                    <th data-dynatable-column="duration">Aufenthalt in Min</th>
                                    </thead>
                                    <tbody>
                                    </tbody>
                                </table>
                            </div>
                        </p>
                    </div>
                </div>
                <div class="row sub">
                    <div class="col-md-9 col-lg-9 col-xl-9">
                        <h2>Zustrom / Abfluss</h2>
                        <canvas id="canvas_diagramm" style="border:1px solid #E65858;border-radius:4px;"></canvas>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
<hr>
<footer>
    <div class="row">
        <div class="col-md-6">
            <p>&copy; <script>document.write(new Date().getFullYear())</script> serviceBLICK by planBLICK GmbH</p>
        </div>
        <div class="col-md-6 text-md-right">
            <a href="#" class="text-dark">Impressum</a>
            <span class="text-muted mx-2">|</span>
            <a href="#" class="text-dark">Datenschutz</a>
        </div>
    </div>
</footer>
</div>
<video id="video" width="1920" height="1080" style="display:none;"></video>
<canvas id="canvasOutput" width="1920" height="1080" style="display:none;"></canvas>

<!-- Include jquery and init.js. All other includes will be handled in init.js -->
<script src="./pbcdn/vendor/jquery/jquery.min.js?v=[cs_version]"></script>
<script type="module">import {Init} from './js/init.js'; new Init().load();</script>
<script type="module">import {pb_events} from './js/events.js'; window.pb_events = new pb_events();</script>
<script type="module">import {CONFIG} from './pbcdn/config.js'; window.CONFIG = CONFIG;</script>
<script type='text/javascript' src='./pbcdn/vendor/jquery.dynatable.js'></script>

<script type="text/javascript">
document.addEventListener("jquery_cookie_loaded", function (event) {
    fetchData()
    setInterval(fetchData, 3000)
})

var table_initialized = false
function fetchData() {
    apikey = $.cookie("apikey");

    result = false

    url = CONFIG.API_BASE_URL + "/easy2track/current_visitors";
    $.ajax({
        type: "GET",
        url: url,
        data: "",
        beforeSend: function (xhr){
            xhr.setRequestHeader('apikey', apikey);
        },
        success: function (response) {
            data = formatData(response)
            if(!table_initialized) {
                table_initialized = true
                $.dynatableSetup({
                    // your global default options here
                    dataset: {
                        perPageDefault: 10,
                        perPageOptions: [10, 20, 50, 100],
                        sorts: {'status': -1},
                    }
                });

                $('#example').dynatable({
                    dataset: {
                        records: (data)
                    }
                });
            } else {
                console.log($('#example').data('dynatable'))
                var dynatable = $('#example').data('dynatable');
                dynatable.settings.dataset.originalRecords = data;
                dynatable.process();
            }
        },
        error: function(){
            alert("Hey Da ist etwas schief gelaufen. Versuche es bitte noch einmal.")
        }
      }).done(function(o) {

      });
}

function formatData(data) {
    let statistic = {checkins: {7: 0, 8: 0, 9: 0, 10: 0, 11: 0, 12 : 0, 13 : 0, 14 : 0, 15 : 0, 16 : 0, 17 : 0, 18 : 0, 19 : 0, 20 : 0, 21 : 0, 22 : 0, 23: 0},
                    checkouts: {7: 0, 8: 0, 9: 0, 10: 0, 11: 0, 12 : 0, 13 : 0, 14 : 0, 15 : 0, 16 : 0, 17 : 0, 18 : 0, 19 : 0, 20 : 0, 21 : 0, 22 : 0, 23: 0}}
    let current_visitors = 0
    let sum_visitors = 0
    let sum_duration = 0

    for(row_index in data) {

        if (data[row_index]["duration"]) {
            data[row_index]["duration"] = data[row_index]["duration"].toFixed(2)
        } else {
            data[row_index]["duration"] = "-"
        }
        datetimeFormat = "DD.MM.YYYY HH:mm";
        mysqldatetimeFormat = "YYYY-MM-DD HH:mm:ss";

        data[row_index]["checkedin"] = moment.utc(data[row_index]["checkedin"], mysqldatetimeFormat)
        data[row_index]["checkedin_formatted"]= data[row_index]["checkedin"].format(datetimeFormat)
        if(data[row_index]["checkedout"]) {
            data[row_index]["checkedout"] = moment.utc(data[row_index]["checkedout"], mysqldatetimeFormat)
            data[row_index]["checkedout_formatted"] = data[row_index]["checkedout"].format(datetimeFormat)
        } else {
            // After how many minutes a person shall be treated as checked out even if no active checkout exists
            var minutes = $("#auto_logout_minutes").val()
            var check_out_date_faked = data[row_index]["checkedin"].add(minutes, 'minutes')

            if(moment().isAfter(check_out_date_faked.local("Europe/Berlin"))) {
                data[row_index]["checkedout"] = check_out_date_faked
                data[row_index]["checkedout_formatted"] = "<i>" + check_out_date_faked.format(datetimeFormat) + " <span class='auto_checkout_label'>(Auto-Checkout)</span></i>"
                data[row_index]["duration"] = minutes
            } else {
                data[row_index]["checkedout_formatted"] = "-"
            }

        }

        if(parseInt(data[row_index]["duration"]) > 0) {
            sum_duration += parseInt(data[row_index]["duration"])
        }

        let checkin_hour = parseInt(data[row_index]["checkedin"].format("HH"))
        current_visitors++
        sum_visitors++
        if(!statistic.checkins[checkin_hour]) {
            statistic.checkins[checkin_hour] = 1
        } else {
            statistic.checkins[checkin_hour]++;
        }

        if(data[row_index]["checkedout"]) {
            let checkout_hour = parseInt(data[row_index]["checkedout"].format("HH"))
            current_visitors--
            if (!statistic.checkouts[checkout_hour]) {
                statistic.checkouts[checkout_hour] = 1
            } else {
                statistic.checkouts[checkout_hour]++;
            }
        }
    }
    setAverageDuration(sum_duration/sum_visitors)
    setVisitorCounters(current_visitors, sum_visitors)
    renderStatistic(statistic)
    return data
}

function setAverageDuration(duration)
{
    $("#average_duration").html(parseInt(duration))
}

function setVisitorCounters(current_visitors, sum_visitors) {
    $("#current_visitors").html(current_visitors)
    $("#sum_visitors").html(sum_visitors)
}

function renderStatistic(statistic) {
    var canvas = document.getElementById("canvas_diagramm");
    var canvasWidth = 1400;
    var canvasHeight = 350;
    canvas.setAttribute('width', canvasWidth);
    canvas.setAttribute('height', canvasHeight);
    var cv = canvas.getContext("2d");
//Options Grid
    var graphGridSize = 20;
    var graphGridX = (canvasWidth / graphGridSize).toFixed();
//Draw Grid
    for (var i = 0; i < graphGridX; i++) {
        cv.moveTo(canvasWidth, graphGridSize * i);
        cv.lineTo(0, graphGridSize * i);
    }
    cv.strokeStyle = "#dbdbdb";
    cv.stroke();


//Data Graph
    let values = []
    for(i in statistic.checkins) {
        if(typeof statistic.checkins[i] != "undefined") {
            values.push({A: i + "-" + (parseInt(i) + 1) + " Uhr: " + statistic.checkins[i], B: statistic.checkins[i] + 1, C: "#34791f"})
        }
        if(typeof statistic.checkouts[i] != "undefined") {
            values.push({A: "/" + statistic.checkouts[i], B: statistic.checkouts[i] + 1, C: "#e65858"})
        }
    }
    var data = {
        values: values
    };

//Options Graph
    var graphMax = 160;
    var graphPadding = 10;
    var graphFaktor = (canvasHeight - (2 * graphPadding)) / graphMax;
    var graphWidth = (canvasWidth - graphPadding) / data.values.length;
    var graphTextcolor = '#000000';

//Draw Graph
    for (var i = 0; i < data.values.length; i++) {
        let tmpTop = (canvasHeight - (graphFaktor * data.values[i].B)).toFixed() - graphPadding;
        let tmpHeight = ((data.values[i].B * graphFaktor)).toFixed();
        cv.fillStyle = data.values[i].C;
        cv.fillRect(graphWidth + ((i - 1) * graphWidth) + graphPadding, tmpTop, graphWidth - graphPadding, tmpHeight);
        cv.fillStyle = graphTextcolor;
        cv.fillText(data.values[i].A, graphWidth + ((i - 1) * graphWidth) + graphPadding + 2, canvasHeight - 2, graphWidth);
    }
}
</script>
<div id="news_modal" class="ui basic modal news">
  <div class="header">Neuigkeiten<i href="#" onclick="$('#news_modal').modal('hide');return false;" class="close icon news_close" title="News schließen"></i></div>
  <div id="news_container" class="content">
  </div>
    <div>keine News</div>
</div>
</body>
</html>